# -*- coding: utf-8 -*-
from Components.ActionMap import *
from Components.Label import Label
from Components.MenuList import MenuList
from Components.MultiContent import MultiContentEntryText, MultiContentEntryPixmap, MultiContentEntryPixmapAlphaTest
from Components.ConfigList import *
from Components.config import *
from Components.ConfigList import ConfigList, ConfigListScreen
from Components.config import config, ConfigSubsection, ConfigText, getConfigListEntry, ConfigSelection, NoSave
from Components.Button import Button
from Components.Label import Label
from Components.Network import iNetwork
from Components.PluginComponent import plugins

from Screens.HelpMenu import HelpableScreen
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Screens.Screen import Screen

from Plugins.Plugin import PluginDescriptor
from twisted.web.client import getPage
from twisted.web.client import downloadPage

from enigma import ePicLoad
from enigma import eListboxPythonMultiContent, eListbox, gFont, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER, loadPNG, RT_WRAP, eServiceReference, getDesktop, loadJPG

from Tools.NumericalTextInput import NumericalTextInput
from Tools.Directories import pathExists, fileExists, SCOPE_SKIN_IMAGE, resolveFilename

import re, time, urllib, math
from datetime import datetime

config.plugins.tippspiel = ConfigSubsection()
config.plugins.tippspiel.usern = ConfigText(default = "username", fixed_size=False)
config.plugins.tippspiel.passw = ConfigText(default = "password", fixed_size=False)

class ConfigSoccer(ConfigSequence):
	def __init__(self, default):
		soccer_limits = [(0,9),(0,9)]
		ConfigSequence.__init__(self, seperator = ":", limits = soccer_limits, default = default)

class tipperlist(MenuList):
        def __init__(self, list):
                MenuList.__init__(self, list, False, eListboxPythonMultiContent)
                self.l.setFont(0, gFont("Regular", 14))
                self.l.setFont(1, gFont("Regular", 16))
                self.l.setFont(2, gFont("Regular", 18))
                self.l.setFont(3, gFont("Regular", 17))
                self.l.setFont(4, gFont("Regular", 22))
                self.l.setFont(5, gFont("Regular", 24))
                self.l.setFont(6, gFont("Regular", 26))
                self.l.setFont(7, gFont("Regular", 20))
                self.l.setFont(8, gFont("Regular", 19))
                self.l.setItemHeight(22)

class tippen_main(ConfigListScreen, Screen):
	if getDesktop(0).size().width() == 1280:
		skin = """
			<screen position="center,center" size="800,450" title="Tipp Spiel (Login) v0.5" >
				<widget name="config" position="5,0" size="760,50" scrollbarMode="showOnDemand" />
				<widget name="info" position="5,50" size="800,20" zPosition="0" font="Regular;20" transparent="1" foregroundColor="yellow" />
				<widget name="buttonred" position="88,405" size="90,40" backgroundColor="red" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
				<widget name="buttongreen" position="266,405" size="90,40" backgroundColor="green" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
				<widget name="buttonyellow" position="444,405" size="90,40" backgroundColor="yellow" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
				<widget name="buttonblue" position="622,405" size="90,40" backgroundColor="blue" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
			</screen>"""

	def __init__(self, session):
		self.session = session
		Screen.__init__(self, session)

		self["actions"] = ActionMap(["OkCancelActions", "ColorActions", "DirectionActions", "MovieSelectionActions"],
                {
					"yellow": self.open_ranking,
					"green": self.tippen,
					"cancel": self.exit,
					"ok": self.start_login,
                }, -2)
		
		self["buttonred"] = Label(_("Login"))
		self["buttongreen"] = Label(_("Tippen"))
		self["buttonyellow"] = Label(_("Ranking"))		
		self["buttonblue"] = Label(_("Info"))
		self["info"] = Label("")
		self["info"].setText("Set your Username and Password.")

		self.list = []
		self.list.append(getConfigListEntry("User", config.plugins.tippspiel.usern))
		self.list.append(getConfigListEntry("Pass:", config.plugins.tippspiel.passw))
		#current = ConfigSoccer(default=[0,0])
		#self.list.append(getConfigListEntry("", current))
		ConfigListScreen.__init__(self, self.list)

		self.mac_adresse = iNetwork.getAdapterAttribute("eth0", "mac")
		self.login = "False"
		self.username = config.plugins.tippspiel.usern.value
		self.password = config.plugins.tippspiel.passw.value

		if config.plugins.tippspiel.usern.value != "username" and config.plugins.tippspiel.passw.value != "password":
			print "test"
			username = config.plugins.tippspiel.usern.value
			password = config.plugins.tippspiel.passw.value
			self.username = username.replace(' ','')
			self.password = password.replace(' ','')
			print self.password, self.username
			url = "http://timeforplanb.de/logi.php?spieler=%s&pass=%s&version=0.4" % (self.username, self.password)
			data = urllib.urlopen(url).read()
			login = re.findall('<login>(.*?)</login>', data, re.S)
			if login[0] == "False":
				url = "http://timeforplanb.de/mac.php?mac=%s" % self.mac_adresse
				data = urllib.urlopen(url).read()
				mac_yes_or_no = re.findall('<mac>(.*?)</mac>', data, re.S)
				if mac_yes_or_no[0] == "False":
					url = "http://timeforplanb.de/user_exist.php?spieler=%s" % self.username
					data = urllib.urlopen(url).read()
					not_added = re.findall('<spieler>(.*?)</spieler>', data, re.S)
					if not_added[0] == "False":
						print "[Tipp] username: %s erstellt" % self.username
						url = "http://timeforplanb.de/addspieler.php?spieler=%s&pass=%s&mac=%s" % (self.username, self.password, self.mac_adresse)
						data = urllib.urlopen(url).read()
						angelegt = re.findall('<add_spieler>(.*?)</add_spieler>', data, re.S)
						if angelegt[0] == "True":
							self["info"].setText("Username: %s wurde angelegt. Druecke OK zum einloggen." % self.username)
						else:
							self["info"].setText("Username: %s wurde nicht angelegt. Fehler." % self.username)
					else:
						print "[Tipp] username ist bereits vorhanden - waehle einen anderen !"
						self["info"].setText("username ist bereits vorhanden - waehle einen anderen !")
				else:
					print "[Tipp] du bist bereits registriert ! log dich mit deinem alten usernamen und password ein."
					self["info"].setText("du bist bereits registriert ! log dich mit deinem alten usernamen und password ein.")
			else:
				print "[Tipp] username: %s ist eingeloggt.." % self.username
				self["info"].setText("Username: %s ist eingeloggt." % self.username)
				config.plugins.tippspiel.usern.save()
				config.plugins.tippspiel.passw.save()
				self.login = "True"
				#points = self.get_stats
		else:
			print "[Tipp] username: %s login fehlgeschlagen." % self.username
			self["info"].setText("Login fehlgeschlagen. User: %s - Pass: %s" % (self.username, self.password))
			self.login = "False"

	#def get_stats(self):
	#	url = "http://timeforplanb.de/yourrank.php?spieler=%s" % self.username
	#	data = urllib.urlopen(url).read()
	#	stats_infos = re.findall('<spieler>.*?</spieler><punkte>(.*?)</punkte>', data)
	#	return stats_infos

	def start_login(self):
		tippen = "tippen_main"
		self.close(self.session, tippen, self.username, self.password, self.login)

	def tippen(self):
		tippen = "tippen"
		self.close(self.session, tippen, self.username, self.password, self.login)

	def open_ranking(self):
		tippen = "ranking"
		self.close(self.session, tippen, self.username, self.password, self.login)
		
	def exit(self):
		tippen = "exit"
		self.close(self.session, tippen, "", "", "")

class tippen(ConfigListScreen,Screen):
	if getDesktop(0).size().width() == 1280:
		skin = """
			<screen position="center,center" size="800,450" title="Tipp Spiel (Tippen)" >
				<widget name="info" position="5,5" size="800,20" zPosition="0" font="Regular;20" transparent="1" foregroundColor="yellow" />
				<widget name="config" position="5,30" size="700,380" scrollbarMode="showNever" />
				<widget name="config2" position="705,30" size="90,380" scrollbarMode="showNever" />
				<widget name="buttonred" position="88,405" size="90,40" backgroundColor="red" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
				<widget name="buttongreen" position="266,405" size="90,40" backgroundColor="green" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
				<widget name="buttonyellow" position="444,405" size="90,40" backgroundColor="yellow" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
				<widget name="buttonblue" position="622,405" size="90,40" backgroundColor="blue" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
			</screen>"""

	def __init__(self, session, username, password, login):
		self.session = session
		Screen.__init__(self, session)	
		self["buttonred"] = Label(_("Login"))
		self["buttongreen"] = Label(_("Tippen"))
		self["buttonyellow"] = Label(_("Ranking"))
		self["buttonblue"] = Label(_("Info"))

		self["info"] = Label("")
		self["info"].setText("Du kannst deine Tipps mit OK speichern.")

		self["config2"] = tipperlist([])
		self.tipplist = []
		self["config2"].setList(self.tipplist)
		self["config2"].l.setItemHeight(25)

		self["actions"] = ActionMap(["OkCancelActions", "ColorActions", "DirectionActions", "MovieSelectionActions"],
		{
			"red": self.open_tippen_main,
			"cancel": self.exit,
			"ok": self.ok,
			"yellow": self.open_ranking,
                        "up": self.up,
                        "down": self.down,
                        #"left": self.left,
                        #"right": self.right,
		}, -2)

		self.list = []
		ConfigListScreen.__init__(self, self.list)
                self["config"].setList(self.list)

		self.username = username
		self.password = password
		self.login = login
		print "[Tipp] Tippen:", self.username, self.password, self.login
		#self.getit()
		self.onLayoutFinish.append(self.getit)

	def open_tippen_main(self):
		tippen = "tippen_main"
		self.close(self.session, tippen, "", "", "")
		
	def open_ranking(self):
		tippen = "ranking"
		self.close(self.session, tippen, self.username, self.password, self.login)

	def getit(self):
		if self.login == "True":
			#self.tipplist = []
			url = "http://timeforplanb.de/matches.php"
			data = urllib.urlopen(url).read()
			matches = re.findall('<id>(.*?)</id><teams>(.*?)</teams><uhrzeit>(.*?)</uhrzeit><result>(.*?)</result><win>(.*?)</win>', data, re.S)
			#self.list = []
			if matches:
				matches.reverse()
				for each in matches:
					(id, teams, uhrzeit, result, win) = each
					print teams, uhrzeit, result, win
					if int(uhrzeit) > time.time():
						print "11111"
						you_can = "1"
						mein_tipp = self.get_tipp(id)
						print "mein_tipp:", mein_tipp
						now = datetime.fromtimestamp(int(uhrzeit))
						uhr = now.strftime("%a %d.%m %H:%M")
						if result == "999":
							result = "-:-"
						text = "%s      %s" % (uhr, teams)
						current = ConfigSoccer(default=[int(mein_tipp[-3]),int(mein_tipp[-1])])
						self.list.append(getConfigListEntry(text, current, id, uhrzeit, str(teams), result, str(win), you_can))
						self.tipplist.append(self.showranking(result))

					#elif int(uhrzeit) + 864000 > time.time():
					elif int(uhrzeit) + 259200 > time.time():
						print "22222"
						you_can = "2"
						mein_tipp = self.get_tipp(id)
						print "mein_tipp:", mein_tipp
						now = datetime.fromtimestamp(int(uhrzeit))
						uhr = now.strftime("%a %d.%m %H:%M")
						text = "%s      %s" % (uhr, teams)
						current = ConfigSoccer(default=[int(mein_tipp[-3]),int(mein_tipp[-1])])
						current.enabled = False
						result2 = [int(result[-3]), int(result[-1])]
						tipp2 =  [int(mein_tipp[-3]), int(mein_tipp[-1])]
						my_points = self.getPoints(result2,tipp2)
						self.list.append(getConfigListEntry(text, current, id, uhrzeit, str(teams), result, str(win), you_can))
						self.tipplist.append(self.showranking2(result, my_points))
			else:
				self["info"].setText("Zurzeit sind keine Spiele zum tippen vorhanden.")
		else:
			self["info"].setText("Du bist nicht eingeloggt !")

	def showranking(self, result):
		res = [ (result) ]
		print "result:", result
		res.append(MultiContentEntryText(pos=(4, 0), size=(45, 20), font=1, text=result, flags=RT_HALIGN_CENTER))
		return res

	def showranking2(self, result, my_points):
		res = [ (result, my_points) ]
		my_points = "%sp" % my_points
		res.append(MultiContentEntryText(pos=(5, 0), size=(45, 20), font=1, text=result, flags=RT_HALIGN_CENTER))
		res.append(MultiContentEntryText(pos=(45, 0), size=(45, 20), font=1, text=str(my_points), flags=RT_HALIGN_CENTER))
		return res

	def checkResult(self, result):
        	ret = 0 #draw
        	if result[0] > result[1]:
                	ret = 1 #home
        	elif result[0] < result[1]:
                	ret = 2 #guest
        	return ret

	def getPoints(self, result, tipp):
        	won = self.checkResult(result) == self.checkResult(tipp)
        	if won:
                	tend = 9
                	diff = math.fabs(result[0] - tipp[0]) + math.fabs(result[1] - tipp[1])
                	tend = tend - diff
                	if tend < 0:
                        	tend = 0
                	return 1 + tend
        	return 0

	def leerz(self, nr):
		ok = ""
		for i in range(nr):
			ok = ok + " "
		return ok

	def up(self):
		print "hoch"
		self["config2"].up()
		if self["config"].getCurrentIndex() <= len(self["config"].getList()) -1:
			current_nr = self["config"].getCurrentIndex() - 1
			self["config"].setCurrentIndex(int(current_nr))

        def down(self):
		print "runter"
		self["config2"].down()
		count_listentrys = len(self["config"].getList()) -1
		print count_listentrys
		if not self["config"].getCurrentIndex() >= len(self["config"].getList()) -1:
			current_nr = self["config"].getCurrentIndex() + 1
			self["config"].setCurrentIndex(int(current_nr))

	def exit(self):
		tippen = "exit"
		self.close(self.session, tippen, "", "", "")

	def ok(self):
		for each in self["config"].list:
			callback_d = each[1].value
			callback = "%s:%s" % (callback_d[0], callback_d[1])
			matchid = each[2]
			teams = each[4]
			print callback, matchid, teams
			if self.login == "True":
				url = "http://timeforplanb.de/get_tipps.php?matchid=%s&spieler=%s" % (matchid, self.username)
				data = urllib.urlopen(url).read()
				matches = re.findall('<tipp>(.*?)</tipp>', data, re.S)
				if not matches:
					url = "http://timeforplanb.de/send_tipp.php?spieler=%s&matchid=%s&tipp=%s" % (self.username, matchid, callback)
					data = urllib.urlopen(url).read()
					true = re.findall('<send_tipp>(.*?)</send_tipp>', data, re.S)
					if true:
						print "[Tipp] Neuer Tipp erstellt:", teams, matchid, callback
						self["info"].setText("Deine Tipps wurden gespeichert.")
						#self.getit()
					else:
						print "[Tipp] Es gab einen fehler beim abgeben deines Tipps."
						self["info"].setText("Es gab einen fehler beim abgeben deines Tipps.")
				else:
					url = "http://timeforplanb.de/change_tipp.php?spieler=%s&matchid=%s&tipp=%s" % (self.username, matchid, callback)
					data = urllib.urlopen(url).read()
					true2 = re.findall('<change_tipp>(.*?)</change_tipp>', data, re.S)
					if true2:
						print "[Tipp] updated:", teams, matchid, callback
						self["info"].setText("Tipp: %s updated." % callback)
						#self.getit()
					else:
						print "[Tipp] Es gab einen fehler beim abgeben deines Tipps."
						self["info"].setText("Es gab einen fehler beim abgeben deines Tipps.")
			else:
				self["info"].setText("Du bist nicht eingeloggt !")
				print "[Tipp] Bitte einloggen !"
		#self.getit()

	def get_tipp(self, matchid):
		url = "http://timeforplanb.de/get_tipps.php?matchid=%s&spieler=%s" % (matchid, self.username)
		data = urllib.urlopen(url).read()
		matches = re.findall('<tipp>(.*?)</tipp>', data, re.S)
		#if len(matches[0]) == 3 and matches[0] != "999":
		if matches:
			if len(matches[0]) == 3:
				print matches[0]
				return matches[0]
			else:
				print str("0:0")
				return str("0:0")
		else:
			print str("0:0")
			return str("0:0")

class ranking(Screen):
	if getDesktop(0).size().width() == 1280:
		skin = """
			<screen position="center,center" size="800,450" title="Tipp Spiel (Ranking)" >
				<widget name="info" position="5,5" size="800,20" zPosition="0" font="Regular;20" transparent="1" foregroundColor="yellow" />
				<widget name="info2" position="5,25" size="800,20" zPosition="0" font="Regular;20" transparent="1" foregroundColor="yellow" />
				<widget name="ranks_info" position="5,50" size="740,25" scrollbarMode="showOnDemand" />
				<widget name="ranks" position="5,75" size="740,325" scrollbarMode="showOnDemand" />
				<widget name="buttonred" position="88,405" size="90,40" backgroundColor="red" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
				<widget name="buttongreen" position="266,405" size="90,40" backgroundColor="green" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
				<widget name="buttonyellow" position="444,405" size="90,40" backgroundColor="yellow" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
				<widget name="buttonblue" position="622,405" size="90,40" backgroundColor="blue" valign="center" halign="center" zPosition="1" foregroundColor="black" font="Regular;22"/>
			</screen>"""

	def __init__(self, session, username, password, login):
		self.session = session
		Screen.__init__(self, session)

		self["actions"] = ActionMap(["OkCancelActions", "ColorActions", "DirectionActions", "MovieSelectionActions"],
                {
			"green": self.tippen,
			"red": self.open_tippen_main,
			"cancel": self.exit,
                        "up": self.up,
                        "down": self.down,
                        "left": self.left,
                        "right": self.right,
                }, -2)
		
		self["info"] = Label("")
		self["info2"] = Label("")
		self["buttonred"] = Label(_("Login"))
		self["buttongreen"] = Label(_("Tippen"))
		self["buttonyellow"] = Label(_("Ranking"))
		self["buttonblue"] = Label(_("Info"))
		self["ranks"] = tipperlist([])
		self["ranks_info"] = tipperlist([])

		self.username = username
                self.password = password
		self.login = login
                print "[Tipp] Ranking:", self.username, self.password, self.login
		self.onLayoutFinish.append(self.get_ranking)

	def get_ranking(self):
		if self.login == "True":
			self.tipplist = []
			self.tipplist2 = []
			url = "http://timeforplanb.de/ranking.php"
			data = urllib.urlopen(url).read()
			ranking = re.findall('<spieler>(.*?)</spieler><punkte>(.*?)</punkte>', data, re.S)
			counting = 0
			total_punkte = 0
			self.tipplist2.append(self.showranking("Spieler", "Punkte", "#", "Tipps", "Richtig"))
			self["ranks_info"].l.setList(self.tipplist2)
			self["ranks_info"].l.setItemHeight(25)
			self["ranks_info"].selectionEnabled(0)
			for each in ranking:
				counting = counting + 1
				(spieler, punkte) = each
				total_punkte = int(total_punkte) + int(punkte)
				url = "http://timeforplanb.de/alltipps.php?spieler=%s" % spieler
				data = urllib.urlopen(url).read()
				total_tipps = re.findall('<tipps>(.*?)</tipps>', data, re.S)
				self.tipplist.append(self.showranking(spieler, punkte, counting, total_tipps[0], punkte))
			self["ranks"].l.setList(self.tipplist)
			self["ranks"].l.setItemHeight(25)
			self["ranks"].selectionEnabled(1)
			self["info"].setText("Anzahl der Spieler: %s" % counting)
			self["info2"].setText("Anzahl der Gesamtpunkte: %s" % total_punkte)
		else:
			self["info"].setText("Du bist nicht eingeloggt !")

	def showranking(self, spieler, punkte, counting, total_tipps, richtig):
		res = [ (spieler, punkte, counting, total_tipps, richtig) ]
		if str(spieler) == str(self.username):
			res.append(MultiContentEntryText(pos=(10, 0), size=(50, 25), font=8, color=0x00dab329, text=str(counting), flags=RT_HALIGN_LEFT))
			res.append(MultiContentEntryText(pos=(80, 0), size=(200, 25), font=8, color=0x00dab329, text=str(spieler), flags=RT_HALIGN_LEFT))
			res.append(MultiContentEntryText(pos=(280, 0), size=(80, 25), font=8, color=0x00dab329, text=str(punkte), flags=RT_HALIGN_RIGHT))
			res.append(MultiContentEntryText(pos=(360, 0), size=(80, 25), font=8, color=0x00dab329, text=str(total_tipps), flags=RT_HALIGN_RIGHT))
			res.append(MultiContentEntryText(pos=(440, 0), size=(80, 25), font=8, color=0x00dab329, text=str(richtig), flags=RT_HALIGN_RIGHT))
		else:
			res.append(MultiContentEntryText(pos=(10, 0), size=(50, 25), font=8, text=str(counting), flags=RT_HALIGN_LEFT))
			res.append(MultiContentEntryText(pos=(80, 0), size=(200, 25), font=8, text=str(spieler), flags=RT_HALIGN_LEFT))
			res.append(MultiContentEntryText(pos=(280, 0), size=(80, 25), font=8, text=str(punkte), flags=RT_HALIGN_RIGHT))
			res.append(MultiContentEntryText(pos=(360, 0), size=(80, 25), font=8, text=str(total_tipps), flags=RT_HALIGN_RIGHT))
			res.append(MultiContentEntryText(pos=(440, 0), size=(80, 25), font=8, text=str(richtig), flags=RT_HALIGN_RIGHT))
		return res

	def open_tippen_main(self):
		tippen = "tippen_main"
		self.close(self.session, tippen, "", "", "")
		
	def tippen(self):
		tippen = "tippen"
		self.close(self.session, tippen, self.username, self.password, self.login)
		
	def exit(self):
		tippen = "exit"
		self.close(self.session, tippen, "", "", "")		

        def up(self):
                self["ranks"].up()

        def down(self):
                self["ranks"].down()

        def left(self):
                self["ranks"].pageUp()

        def right(self):
                self["ranks"].pageDown()
		
def main(session, **kwargs):
        session.openWithCallback(closen,tippen_main)

def closen(session, result, username, password, login):
	if result == "tippen":
		print "[Tipp] starte screen tippen."
		session.openWithCallback(closen,tippen,username,password,login)
	elif result == "tippen_main":
		print "[Tipp] starte screen tippen_main."
		session.openWithCallback(closen,tippen_main)
	elif result == "ranking":
		print "[Tipp] starte screen ranking."
		session.openWithCallback(closen,ranking,username,password,login)
	elif result == "exit":
		pass

def Plugins(path, **kwargs):
        return [
		PluginDescriptor(name="Tipp Spiel", description="Bundesliga Tipp Spiel", where = [PluginDescriptor.WHERE_EXTENSIONSMENU], fnc=main),
		PluginDescriptor(name="Tipp Spiel", description="Bundesliga Tipp Spiel", where = [PluginDescriptor.WHERE_PLUGINMENU], fnc=main)
		]
